;######   #####  #######                                           
;#     # #     # #        ####   ####   ####  #    # #    # #####  
;#     # #       #       #    # #      #    # #    # ##   # #    # 
;######  #       #####   #       ####  #    # #    # # #  # #    # 
;#     # #       #       #           # #    # #    # #  # # #    # 
;#     # #     # #       #    # #    # #    # #    # #   ## #    # 
;######   #####  #        ####   ####   ####   ####  #    # #####  
;Olivier Baudouin, 2015

;file BCF.inc


#ifndef BCFPATH
  #define BCFPATH ##
#endif

#ifndef BCFBACKUPPATH
#define BCFBACKUPPATH ##
#endif

;========================================================
    instr BCFexit

exitnow

    endin



;========================================================
    instr BCFtoFiles

iBackup, iChn, iTf1, iTf2, iTf3, iTf4, iTf5, iTf6, iTf7 passign 4


if (iBackup == 0) then
  Smess1 sprintf "\\nSAVING TABLES (preset %i)...\\n", iChn
  S1 sprintf "$BCFPATHBCF%i-F1", iChn 
  S2 sprintf "$BCFPATHBCF%i-F2", iChn 
  S3 sprintf "$BCFPATHBCF%i-F3", iChn 
  S4 sprintf "$BCFPATHBCF%i-F4", iChn 
  S5 sprintf "$BCFPATHBCF%i-F5", iChn 
  S6 sprintf "$BCFPATHBCF%i-F6", iChn 
  S7 sprintf "$BCFPATHBCF%i-F7", iChn 
else
  Smess1 sprintf "\\nTABLES BACKUP (preset %i)...\\n", iChn

  Stim dates
  Syear    strsub    Stim, 20, 24
  Smonth   strsub    Stim, 4, 7
  Sday     strsub    Stim, 8, 10
  Shor     strsub    Stim, 11, 13
  Smin     strsub    Stim, 14, 16
  Ssec     strsub    Stim, 17, 19
  Stimf sprintfk "%s%s%s_%sh%sm%ss", Syear, Smonth, Sday, Shor, Smin, Ssec

  S1 sprintf "$BCFBACKUPPATH%s_BCF%i-F1", Stimf, iChn 
  S2 sprintf "$BCFBACKUPPATH%s_BCF%i-F2", Stimf, iChn 
  S3 sprintf "$BCFBACKUPPATH%s_BCF%i-F3", Stimf, iChn 
  S4 sprintf "$BCFBACKUPPATH%s_BCF%i-F4", Stimf, iChn 
  S5 sprintf "$BCFBACKUPPATH%s_BCF%i-F5", Stimf, iChn 
  S6 sprintf "$BCFBACKUPPATH%s_BCF%i-F6", Stimf, iChn 
  S7 sprintf "$BCFBACKUPPATH%s_BCF%i-F7", Stimf, iChn
endif

prints Smess1

ftsave S1, 0, iTf1
ftsave S2, 0, iTf2
ftsave S3, 0, iTf3
ftsave S4, 0, iTf4
ftsave S5, 0, iTf5
ftsave S6, 0, iTf6
ftsave S7, 0, iTf7

prints "... OK!\\n\\n"

turnoff

    endin



;========================================================
    instr BCF2L

iChn, iCC passign 4

ctrlinit iChn, iCC, 127
outic iChn, iCC, 1, 0, 1

turnoff

    endin

 

;========================================================
    opcode BCF1, kkkkkkkkkkkkkkkkkkkkkkk, iiooo

#include "BCFOPCODE.inc"

    endop



#ifdef BCF2
;========================================================
    opcode BCF2, kkkkkkkkkkkkkkkkkkkkkkk, iiooo

#include "BCFOPCODE.inc"

    endop
#end



#ifdef BCF3
;========================================================
    opcode BCF3, kkkkkkkkkkkkkkkkkkkkkkk, iiooo

#include "BCFOPCODE.inc"

    endop
#end



#ifdef BCF4
;========================================================
    opcode BCF4, kkkkkkkkkkkkkkkkkkkkkkk, iiooo

#include "BCFOPCODE.inc"

    endop
#end


;END of file BCF.inc
