;######   #####  #######                                           
;#     # #     # #        ####   ####   ####  #    # #    # #####  
;#     # #       #       #    # #      #    # #    # ##   # #    # 
;######  #       #####   #       ####  #    # #    # # #  # #    # 
;#     # #       #       #           # #    # #    # #  # # #    # 
;#     # #     # #       #    # #    # #    # #    # #   ## #    # 
;######   #####  #        ####   ####   ####   ####  #    # #####  
;Olivier Baudouin, 2015

;file BCFOPCODE.inc


;---------;
;OPCODE IN;
;---------;

iChn, iMode, iDur_, iCtrlChn, iDisp xin

iDur = iDur_+20 ;20 sec. = safety margin 
;-------------------;
;MIDI INITIALIZATION;
;-------------------;

;load last shot
iTshot ftgen 0, 0, -38, -7, 0, 37, 0
iTF8 ftgen 0, 0, -2, -7, 0, 1, 0
Sshot sprintf "$BCFPATHBCF%i-SHOT", iChn
SF8 = "$BCFPATHBCFBCF-SHOTF8" 
iValidShot filevalid Sshot
iValidF8 filevalid SF8

;init foot switch, pav3, pav4, r8, m8, as precaution
cigoto (iChn != iCtrlChn), SKIPINITCTRLi
  ctrlinit iCtrlChn, 11, 0, 23, 0, \\
              24, 0, 68, 0, 78, 0
  outic iCtrlChn, 11, 0, 0, 1
  outic iCtrlChn, 23, 0, 0, 1
  outic iCtrlChn, 24, 0, 0, 1
  outic iCtrlChn, 68, 0, 0, 1
  outic iCtrlChn, 78, 0, 0, 1
SKIPINITCTRLi:

;pad, as precaution
outic iChn, 21, 0, 0, 1
outic iChn, 22, 0, 0, 1

SHOTRESTORE: 
 ;before tab_i to get last recorded data

;load (or reload) shot and F8 
if (iValidShot == 1) then
  ftload Sshot, 0, iTshot
endif
if (iValidF8 == 1) then
  ftload SF8, 0, iTF8 
endif

;read shot
if1 tab_i 1, iTshot
if2 tab_i 2, iTshot
if3 tab_i 3, iTshot
if4 tab_i 4, iTshot
if5 tab_i 5, iTshot
if6 tab_i 6, iTshot
if7 tab_i 7, iTshot
ib1 tab_i 8, iTshot
ib2 tab_i 9, iTshot
ib3 tab_i 10, iTshot
ib4 tab_i 11, iTshot
ib5 tab_i 12, iTshot
ib6 tab_i 13, iTshot
ib7 tab_i 14, iTshot
ib8 tab_i 15, iTshot
im1 tab_i 16, iTshot
im2 tab_i 17, iTshot
im3 tab_i 18, iTshot
im4 tab_i 19, iTshot
im5 tab_i 20, iTshot
im6 tab_i 21, iTshot
im7 tab_i 22, iTshot
ir1 tab_i 23, iTshot
ir2 tab_i 24, iTshot
ir3 tab_i 25, iTshot
ir4 tab_i 26, iTshot
ir5 tab_i 27, iTshot
ir6 tab_i 28, iTshot
ir7 tab_i 29, iTshot
ie1 tab_i 30, iTshot
ie2 tab_i 31, iTshot
ie3 tab_i 32, iTshot
ie4 tab_i 33, iTshot
ie5 tab_i 34, iTshot
ie6 tab_i 35, iTshot
ie7 tab_i 36, iTshot
ie8 tab_i 37, iTshot

if8 tab_i 0, iTF8

;init faders
initc14 iChn, 1, 33, if1/16383
initc14 iChn, 2, 34, if2/16383
initc14 iChn, 3, 35, if3/16383
initc14 iChn, 4, 36, if4/16383
initc14 iChn, 5, 37, if5/16383
initc14 iChn, 6, 38, if6/16383
initc14 iChn, 7, 39, if7/16383

initc14 iCtrlChn, 8, 40, if8/16383
;init encoders
ctrlinit iChn, 41, ie1, 42, ie2, 43, ie3, 44, ie4, \\
            45, ie5, 46, ie6, 47, ie7, 48, ie8
;init push buttons of encoders
ctrlinit iChn, 51, ib1*127, 52, ib2*127, 53, ib3*127, \\
            54, ib4*127, 55, ib5*127, 56, ib6*127, \\
            57, ib7*127, 58, ib8*127
;init reading push buttons
ctrlinit iChn, 61, im1*127, 62, im2*127, 63, im3*127, \\
		 	64, im4*127, 65, im5*127, 66, im6*127, \\
	 		67, im7*127
;init recording push buttons
ctrlinit iChn, 71, ir1*127, 72, ir2*127, 73, ir3*127, \\
			74, ir4*127, 75, ir5*127, 76, ir6*127, \\
			77, ir7*127 

rireturn ;SHOTRESTORE


;------------------;
;BCF INITIALIZATION;
;------------------;

;faders
outic14 iChn, 1, 33, if1, 0, 16383
outic14 iChn, 2, 34, if2, 0, 16383
outic14 iChn, 3, 35, if3, 0, 16383
outic14 iChn, 4, 36, if4, 0, 16383
outic14 iChn, 5, 37, if5, 0, 16383
outic14 iChn, 6, 38, if6, 0, 16383
outic14 iChn, 7, 39, if7, 0, 16383

kf1 init if1 ;because of init into SHOTRESTORE
kf2 init if2
kf3 init if3
kf4 init if4
kf5 init if5
kf6 init if6
kf7 init if7

;init f8
outic14 iCtrlChn, 8, 40, if8, 0, 16383
;encoders
outic iChn, 41, ie1, 0, 127
outic iChn, 42, ie2, 0, 127
outic iChn, 43, ie3, 0, 127
outic iChn, 44, ie4, 0, 127
outic iChn, 45, ie5, 0, 127
outic iChn, 46, ie6, 0, 127
outic iChn, 47, ie7, 0, 127
outic iChn, 48, ie8, 0, 127
;push buttons of encoders
outic iChn, 51, ib1, 0, 1
outic iChn, 52, ib2, 0, 1
outic iChn, 53, ib3, 0, 1
outic iChn, 54, ib4, 0, 1
outic iChn, 55, ib5, 0, 1
outic iChn, 56, ib6, 0, 1
outic iChn, 57, ib7, 0, 1
outic iChn, 58, ib8, 0, 1
;reading push buttons
outic iChn, 61, im1, 0, 1
outic iChn, 62, im2, 0, 1
outic iChn, 63, im3, 0, 1
outic iChn, 64, im4, 0, 1
outic iChn, 65, im5, 0, 1
outic iChn, 66, im6, 0, 1
outic iChn, 67, im7, 0, 1
;recording push buttons
outic iChn, 71, ir1, 0, 1
outic iChn, 72, ir2, 0, 1
outic iChn, 73, ir3, 0, 1
outic iChn, 74, ir4, 0, 1
outic iChn, 75, ir5, 0, 1
outic iChn, 76, ir6, 0, 1
outic iChn, 77, ir7, 0, 1


;--> single mode
if (iMode == 0) then
  prints "\\nSINGLE MODE\\n\\n"
  igoto SINGLEMODE1
endif


;---------------------;
;TABLES INITIALIZATION;
;---------------------;

iTf1 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0
iTf2 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0
iTf3 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0
iTf4 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0
iTf5 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0
iTf6 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0
iTf7 ftgen 0, 0, iDur*kr, -7, 0, iDur*kr, 0

S1 sprintf "$BCFPATHBCF%i-F1", iChn 
S2 sprintf "$BCFPATHBCF%i-F2", iChn 
S3 sprintf "$BCFPATHBCF%i-F3", iChn 
S4 sprintf "$BCFPATHBCF%i-F4", iChn 
S5 sprintf "$BCFPATHBCF%i-F5", iChn 
S6 sprintf "$BCFPATHBCF%i-F6", iChn 
S7 sprintf "$BCFPATHBCF%i-F7", iChn

;load tables
iValidTf1 filevalid S1
if (iValidTf1 == 1) then
  ftload S1, 0, iTf1
endif
iValidTf2 filevalid S2
if (iValidTf2 == 1) then
  ftload S2, 0, iTf2
endif
iValidTf3 filevalid S3
if (iValidTf3 == 1) then
  ftload S3, 0, iTf3
endif
iValidTf4 filevalid S4
if (iValidTf4 == 1) then
  ftload S4, 0, iTf4
endif
iValidTf5 filevalid S5
if (iValidTf5 == 1) then
  ftload S5, 0, iTf5
endif
iValidTf6 filevalid S6
if (iValidTf6 == 1) then
  ftload S6, 0, iTf6
endif
iValidTf7 filevalid S7
if (iValidTf7 == 1) then
  ftload S7, 0, iTf7
endif

;-----------;
SINGLEMODE1:;
;-----------;


;--------;
;READ BCF;
;--------;

;encoders
ke1 ctrl7 iChn, 41, 0, 127
ke2 ctrl7 iChn, 42, 0, 127
ke3 ctrl7 iChn, 43, 0, 127
ke4 ctrl7 iChn, 44, 0, 127
ke5 ctrl7 iChn, 45, 0, 127
ke6 ctrl7 iChn, 46, 0, 127
ke7 ctrl7 iChn, 47, 0, 127
ke8 ctrl7 iChn, 48, 0, 127
;push buttons of encoders
kb1 ctrl7 iChn, 51, 0, 1
kb2 ctrl7 iChn, 52, 0, 1
kb3 ctrl7 iChn, 53, 0, 1
kb4 ctrl7 iChn, 54, 0, 1
kb5 ctrl7 iChn, 55, 0, 1
kb6 ctrl7 iChn, 56, 0, 1
kb7 ctrl7 iChn, 57, 0, 1
kb8 ctrl7 iChn, 58, 0, 1
;reading push buttons
km1 ctrl7 iChn, 61, 0, 1
outkc iChn, 61, km1, 0, 1
 ;for BCF2L to work well  
km2 ctrl7 iChn, 62, 0, 1
outkc iChn, 62, km2, 0, 1
km3 ctrl7 iChn, 63, 0, 1
outkc iChn, 63, km3, 0, 1
km4 ctrl7 iChn, 64, 0, 1
outkc iChn, 64, km4, 0, 1
km5 ctrl7 iChn, 65, 0, 1
outkc iChn, 65, km5, 0, 1
km6 ctrl7 iChn, 66, 0, 1
outkc iChn, 66, km6, 0, 1
km7 ctrl7 iChn, 67, 0, 1
outkc iChn, 67, km7, 0, 1
km8 ctrl7 iCtrlChn, 68, 0, 1
 ;m8 : no BCF2L
;recording push buttons
kr1 ctrl7 iChn, 71, 0, 1
kr2 ctrl7 iChn, 72, 0, 1
kr3 ctrl7 iChn, 73, 0, 1
kr4 ctrl7 iChn, 74, 0, 1
kr5 ctrl7 iChn, 75, 0, 1
kr6 ctrl7 iChn, 76, 0, 1
kr7 ctrl7 iChn, 77, 0, 1
kr8 ctrl7 iCtrlChn, 78, 0, 1
;pad
kp1 ctrl7 iChn, 21, 0, 1
kp2 ctrl7 iChn, 22, 0, 1
kp3 ctrl7 iCtrlChn, 23, 0, 1
kp4 ctrl7 iCtrlChn, 24, 0, 1
;foot switch
kSw ctrl7 iCtrlChn, 11, 0, 1

;--------------;
;TIME SCROLLING;
;--------------;

kLastTk init 0
kRTk timek
kLastT init 0
kRT times

;time leap
if (kr8 == 0) then
  kf8 ctrl14 iCtrlChn, 8, 40, 0, 16383
endif

;detect f8 movements
ktrig_f8 changed kf8
if (ktrig_f8 == 1 || km8 == 1) then
  kLastT = kRT
  kLastTk = kRTk
endif

;calculation of time index (sec. and k-rate)
kCT = kf8 + kRT-kLastT
kCTk = kf8*kr + kRTk - kLastTk


;display time and f8 current position
cggoto (iDisp == 0 || iChn != iCtrlChn), SKIPDISP
  ktrig_metro metro 10
  printf "%6.2f  |  %6.2f\r", ktrig_metro, kCT, kf8
SKIPDISP:


;-------;
;EXITNOW;
;-------;
schedkwhen kp3, 0, 0, "BCFexit", 0, 0


cggoto (iMode == 1), FULLMODE


;-----------;
;SINGLE MODE;
;-----------;

kf1 ctrl14 iChn, 1, 33, 0, 16383
kf2 ctrl14 iChn, 2, 34, 0, 16383
kf3 ctrl14 iChn, 3, 35, 0, 16383
kf4 ctrl14 iChn, 4, 36, 0, 16383
kf5 ctrl14 iChn, 5, 37, 0, 16383
kf6 ctrl14 iChn, 6, 38, 0, 16383
kf7 ctrl14 iChn, 7, 39, 0, 16383

cggoto (iMode == 0), SINGLEMODE2


;--------;
FULLMODE:;
;--------;

;SAVE OR BACKUP TABLES
ktrig_p2 changed kp2
if (ktrig_p2 == 1 && kp2 == 1) then
  kdurp2 = kCT
elseif (ktrig_p2 == 1 && kp2 == 0) then
  kTbackup = kCT-kdurp2
endif

if (kTbackup >= 0.5) then
  ktrig_p2b = 1
  kBackup = 1
elseif (kTbackup > 0 && kTbackup < 0.5) then
  ktrig_p2b = 1
  kBackup = 0
else
  ktrig_p2b = 0
endif

schedkwhen ktrig_p2b, 1, 1, "BCFtoFiles", 0, 10, \\
      kBackup, iChn, iTf1, iTf2, iTf3, iTf4, iTf5, iTf6, iTf7 

kTbackup = 0


;PLAY MODE
if (km1 == 1 && kr1*kSw == 0) then
  kf1 tab kCTk, iTf1
endif
if (km2 == 1 && kr2*kSw == 0) then
  kf2 tab kCTk, iTf2
endif
if (km3 == 1 && kr3*kSw == 0) then
  kf3 tab kCTk, iTf3
endif
if (km4 == 1 && kr4*kSw == 0) then
  kf4 tab kCTk, iTf4
endif
if (km5 == 1 && kr5*kSw == 0) then
  kf5 tab kCTk, iTf5
endif
if (km6 == 1 && kr6*kSw == 0) then
  kf6 tab kCTk, iTf6
endif
if (km7 == 1 && kr7*kSw == 0) then
  kf7 tab kCTk, iTf7
endif

;REACTUATING FADERS
  ;in order to stabilize faders at their current positions
ktrig_m1 changed km1
ktrig_m2 changed km2
ktrig_m3 changed km3
ktrig_m4 changed km4
ktrig_m5 changed km5
ktrig_m6 changed km6
ktrig_m7 changed km7
ktrig_m8 changed km8

if (ktrig_m1 == 1) then
  REINITF1i:
  initc14 iChn, 1, 33, i(kf1)/16383
  outic14 iChn, 1, 33, i(kf1), 0, 16383
  reinit REINITF1i
  rireturn
endif
if (ktrig_m2 == 1) then
  REINITF2i:
  initc14 iChn, 2, 34, i(kf2)/16383
  outic14 iChn, 2, 34, i(kf2), 0, 16383
  reinit REINITF2i
  rireturn
endif
if (ktrig_m3 == 1) then
  REINITF3i:
  initc14 iChn, 3, 35, i(kf3)/16383
  outic14 iChn, 3, 35, i(kf3), 0, 16383
  reinit REINITF3i
  rireturn
endif
if (ktrig_m4 == 1) then
  REINITF4i:
  initc14 iChn, 4, 36, i(kf4)/16383
  outic14 iChn, 4, 36, i(kf4), 0, 16383
  reinit REINITF4i
  rireturn
endif
if (ktrig_m5 == 1) then
  REINITF5i:
  initc14 iChn, 5, 37, i(kf5)/16383
  outic14 iChn, 5, 37, i(kf5), 0, 16383
  reinit REINITF5i
  rireturn
endif
if (ktrig_m6 == 1) then
  REINITF6i:
  initc14 iChn, 6, 38, i(kf6)/16383
  outic14 iChn, 6, 38, i(kf6), 0, 16383
  reinit REINITF6i
  rireturn
endif
if (ktrig_m7 == 1) then
  REINITF7i:
  initc14 iChn, 7, 39, i(kf7)/16383
  outic14 iChn, 7, 39, i(kf7), 0, 16383
  reinit REINITF7i
  rireturn
endif

;ACTUATING MOTORS
if (int(kb8-km1) + kr1*kSw == 0 || ktrig_m1+ktrig_m8 >= 1) then
  outkc14 iChn, 1, 33, kf1+ktrig_m1, 0, 16383
   ;"+ ktrig_m" permits actuation when km changes
   ;with a small fader scale (e.g 1 unit = 5mm), we see that the fader is not
    ;exactly at its place, but csound and BCF data are not affected by that
endif
if (int(kb8-km2) + kr2*kSw == 0 || ktrig_m2+ktrig_m8 >= 1) then
  outkc14 iChn, 2, 34, kf2+ktrig_m2, 0, 16383
endif
if (int(kb8-km3) + kr3*kSw == 0 || ktrig_m3+ktrig_m8 >= 1) then
  outkc14 iChn, 3, 35, kf3+ktrig_m3, 0, 16383
endif
if (int(kb8-km4) + kr4*kSw == 0 || ktrig_m4+ktrig_m8 >= 1) then
  outkc14 iChn, 4, 36, kf4+ktrig_m4, 0, 16383
endif
if (int(kb8-km5) + kr5*kSw == 0 || ktrig_m5+ktrig_m8 >= 1) then
  outkc14 iChn, 5, 37, kf5+ktrig_m5, 0, 16383
endif
if (int(kb8-km6) + kr6*kSw == 0 || ktrig_m6+ktrig_m8 >= 1) then
  outkc14 iChn, 6, 38, kf6+ktrig_m6, 0, 16383
endif
if (int(kb8-km7) + kr7*kSw == 0 || ktrig_m7+ktrig_m8 >= 1) then
  outkc14 iChn, 7, 39, kf7+ktrig_m7, 0, 16383
endif

;MANUAL MODE
 ;when no playing + no recording
  ;OR when recording (rec. + foot sw.)
if (km1 + kr1 == 0 || kSw * kr1 != 0) then
  kf1 ctrl14 iChn, 1, 33, 0, 16383
endif
if ( km2 + kr2 == 0 || kSw * kr2 != 0) then
  kf2 ctrl14 iChn, 2, 34, 0, 16383
endif
if ( km3 + kr3 == 0 || kSw * kr3 != 0) then
  kf3 ctrl14 iChn, 3, 35, 0, 16383
endif
if ( km4 + kr4 == 0 || kSw * kr5 != 0) then
  kf4 ctrl14 iChn, 4, 36, 0, 16383
endif
if ( km5 + kr5 == 0 || kSw * kr5 != 0) then
  kf5 ctrl14 iChn, 5, 37, 0, 16383
endif
if ( km6 + kr6 == 0 || kSw * kr6 != 0) then
  kf6 ctrl14 iChn, 6, 38, 0, 16383
endif
if ( km7 + kr7 == 0 || kSw * kr7 != 0) then
  kf7 ctrl14 iChn, 7, 39, 0, 16383
endif

;RECORDING MODE
iTflash ftgen 0, 0, 8, 7, 1, 3, 1, 1, 0, 4, 0  

if (kSw == 1) then
  kFlash oscil 1, 1.2, iTflash

  if (kr1 == 1) then
    tabw kf1, kCTk, iTf1
  endif
  if (kr2 == 1) then
    tabw kf2, kCTk, iTf2
  endif
  if (kr3 == 1) then
    tabw kf3, kCTk, iTf3
  endif
  if (kr4 == 1) then
    tabw kf4, kCTk, iTf4
  endif
  if (kr5 == 1) then
    tabw kf5, kCTk, iTf5
  endif
  if (kr6 == 1) then
    tabw kf6, kCTk, iTf6
  endif
  if (kr7 == 1) then
    tabw kf7, kCTk, iTf7
  endif
else
  kFlash = 1
endif

;motor on/off indicator or rec indicator
outkc iChn, 48, (kb8+kSw)*kFlash, 0, 1

;AUTOMATIC DUAL LAMP
 ;rec. on --> play. on
ktrig_r1 changed kr1, km1
schedkwhen ktrig_r1*kr1, 0.1, 1, "BCF2L", 0, 0, iChn, 61
ktrig_r2 changed kr2, km2
schedkwhen ktrig_r2*kr2, 0.1, 1, "BCF2L", 0, 0, iChn, 62
ktrig_r3 changed kr3, km3
schedkwhen ktrig_r3*kr3, 0.1, 1, "BCF2L", 0, 0, iChn, 63
ktrig_r4 changed kr4, km4
schedkwhen ktrig_r4*kr4, 0.1, 1, "BCF2L", 0, 0, iChn, 64
ktrig_r5 changed kr5, km5
schedkwhen ktrig_r5*kr5, 0.1, 1, "BCF2L", 0, 0, iChn, 65
ktrig_r6 changed kr6, km6
schedkwhen ktrig_r6*kr6, 0.1, 1, "BCF2L", 0, 0, iChn, 66
ktrig_r7 changed kr7, km7
schedkwhen ktrig_r7*kr7, 0.1, 1, "BCF2L", 0, 0, iChn, 67

;WRITE AND SAVE SHOT
if (kp1 == 1) then
  printks "\\n\\nSHOT %i...\\n", 1, iChn
  tabw kf1, 1, iTshot
  tabw kf2, 2, iTshot
  tabw kf3, 3, iTshot
  tabw kf4, 4, iTshot
  tabw kf5, 5, iTshot
  tabw kf6, 6, iTshot
  tabw kf7, 7, iTshot
  tabw kb1, 8, iTshot
  tabw kb2, 9, iTshot
  tabw kb3, 10, iTshot
  tabw kb4, 11, iTshot
  tabw kb5, 12, iTshot
  tabw kb6, 13, iTshot
  tabw kb7, 14, iTshot
  tabw kb8, 15, iTshot
  tabw km1, 16, iTshot
  tabw km2, 17, iTshot
  tabw km3, 18, iTshot
  tabw km4, 19, iTshot
  tabw km5, 20, iTshot
  tabw km6, 21, iTshot
  tabw km7, 22, iTshot
  tabw kr1, 23, iTshot
  tabw kr2, 24, iTshot
  tabw kr3, 25, iTshot
  tabw kr4, 26, iTshot
  tabw kr5, 27, iTshot
  tabw kr6, 28, iTshot
  tabw kr7, 29, iTshot
  tabw ke1, 30, iTshot
  tabw ke2, 31, iTshot
  tabw ke3, 32, iTshot
  tabw ke4, 33, iTshot
  tabw ke5, 34, iTshot
  tabw ke6, 35, iTshot
  tabw ke7, 36, iTshot
  tabw ke8, 37, iTshot

  tabw kf8, 0, iTF8

  REINITSHOTW:
  ftsave Sshot, 0, iTshot
  ftsave SF8, 0, iTF8
  rireturn
  reinit REINITSHOTW
   ;because ftsave runs at init time
  printks "... OK!\\n\\n", 1, iChn
endif

;RESTORE LAST SHOT
krestx2 init 0

if (ktrig_m8*km8 == 1 || krestx2 == 1) then
  krestx2 = km8
   ;krestx2 : for reinit x 2
  reinit SHOTRESTORE

  igoto NORESTOREINIT
   ;to avoid init x2 
  
  ;faders
  outkc14 iChn, 1, 33, kf1+km8, 0, 16383
  outkc14 iChn, 2, 34, kf2+km8, 0, 16383
  outkc14 iChn, 3, 35, kf3+km8, 0, 16383
  outkc14 iChn, 4, 36, kf4+km8, 0, 16383
  outkc14 iChn, 5, 37, kf5+km8, 0, 16383
  outkc14 iChn, 6, 38, kf6+km8, 0, 16383
  outkc14 iChn, 7, 39, kf7+km8, 0, 16383
   ;+km8 : see ACTUATING MOTORS
  ;f8
  outkc14 iCtrlChn, 8, 40, kf8, 0, 16383
  ;encoders
  outkc iChn, 41, ke1, 0, 127
  outkc iChn, 42, ke2, 0, 127
  outkc iChn, 43, ke3, 0, 127
  outkc iChn, 44, ke4, 0, 127
  outkc iChn, 45, ke5, 0, 127
  outkc iChn, 46, ke6, 0, 127
  outkc iChn, 47, ke7, 0, 127
  outkc iChn, 48, ke8, 0, 127
  ;push buttons of encoders
  outkc iChn, 51, kb1, 0, 1
  outkc iChn, 52, kb2, 0, 1
  outkc iChn, 53, kb3, 0, 1
  outkc iChn, 54, kb4, 0, 1
  outkc iChn, 55, kb5, 0, 1
  outkc iChn, 56, kb6, 0, 1
  outkc iChn, 57, kb7, 0, 1
  outkc iChn, 58, kb8, 0, 1
  ;reading push buttons
  outkc iChn, 61, km1, 0, 1
  outkc iChn, 62, km2, 0, 1
  outkc iChn, 63, km3, 0, 1
  outkc iChn, 64, km4, 0, 1
  outkc iChn, 65, km5, 0, 1
  outkc iChn, 66, km6, 0, 1
  outkc iChn, 67, km7, 0, 1
  ;recording push buttons
  outkc iChn, 71, kr1, 0, 1
  outkc iChn, 72, kr2, 0, 1
  outkc iChn, 73, kr3, 0, 1
  outkc iChn, 74, kr4, 0, 1
  outkc iChn, 75, kr5, 0, 1
  outkc iChn, 76, kr6, 0, 1
  outkc iChn, 77, kr7, 0, 1
  NORESTOREINIT:
endif

;-----------;
SINGLEMODE2:;
;-----------;

;----------;
;OPCODE OUT;
;----------;

xout kf1, kf2, kf3, kf4, kf5, kf6, kf7, \\
     ke1, ke2, ke3, ke4, ke5, ke6, ke7, \\
     kb1, kb2, kb3, kb4, kb5, kb6, kb7, \\
     kp4, kCT

;END OF BCFOPCODE.inc
